<template>
  <div
    ref="reference"
    v-click-outside="onOutsideClick"
    class="ob-autocomplete"
    :class="wrapperClass"
    :data-qa="dataQa"
    @click="focusHandler(false)"
  >
    <div class="ob-autocomplete__main">
      <div class="col-left">
        <div class="col-left__label">
          {{ label }}
        </div>
        <div class="col-left__value">
          <template v-if="isSelected">
            <div
              v-if="isSelectedIcon"
              class="col-left__value-icon"
            >
              <i :class="['icon', selectedItem.icon]" />
            </div>
            <template v-if="$scopedSlots.value">
              <slot
                name="value"
                :data="selectedItem"
              />
            </template>
            <template v-else>
              <div
                class="col-left__value-text"
                :title="displayValue"
              >
                {{ displayValue }}
              </div>
            </template>
          </template>
          <template v-else>
            <input
              ref="input"
              v-model="searchQuery"
              v-debounce:300ms="onSearch"
              :tabindex="isDisabled ? -1 : 0"
              :disabled="isDisabled"
              type="text"
              :placeholder="placeholder"
              class="ob-autocomplete__input"
              :data-qa="dataQa"
              @focus="focusHandler(true)"
              @blur="blurHandler"
            >
          </template>
        </div>
      </div>
      <div class="col-right">
        <button
          v-if="isSelected && showClear && !isDisabled"
          tabindex="-1"
          class="ob-autocomplete__action"
          :data-qa="dataQa"
          @click.stop.prevent="onClear"
        >
          <i class="icon close" />
        </button>
        <button
          v-if="isSelect && !isSelected && !isDisabled"
          tabindex="-1"
          class="ob-autocomplete__action"
          :data-qa="dataQa"
          @click.stop.prevent="showResults ? close() : show($event)"
        >
          <i
            class="icon"
            :class="showResults ? 'chevron-up' : 'chevron-down'"
          />
        </button>
        <button
          v-if="actionIcon && !isDisabled || isAlwaysAction"
          tabindex="-1"
          class="ob-autocomplete__action ob-autocomplete__action--out"
          :data-qa="dataQa"
          @click.stop.prevent="onClickAction"
        >
          <i
            :class="['icon', actionIconClass]"
          />
        </button>
        <slot name="extraIcon" />
      </div>
    </div>
    <div
      v-if="$scopedSlots.description && isSelected"
      class="ob-autocomplete__description"
    >
      <slot
        name="description"
        :data="selectedItem"
      />
    </div>
    <select-dropdown
      ref="popper"
      v-model="showResults"
      position="bottom-start"
      :bound-padding="5"
      :popper-class="popperClass"
      :popper-opt="{
        boundPadding: [0, isSelect ? 0 : 5]
      }"
    >
      <div
        v-if="showResults || isLoading"
        ref="list-container"
        v-scroll="handlerScroll"
        class="ob-autocomplete__results"
      >
        <div
          v-for="(item, index) in localItemsFiltered"
          :key="item.title + index"
          class="ob-autocomplete__results-item"
          :class="dropdownItemClass(item)"
          :data-qa="dataQa"
          @click="onSelect(item)"
        >
          <i
            v-if="item.icon"
            :class="['icon', item.icon]"
          />
          <template v-if="$scopedSlots.item">
            <slot
              name="item"
              :data="item"
              :highlight="highlight"
            />
          </template>
          <template v-else>
            <p v-html="highlight(item[valueExp])" />
          </template>
        </div>
        <transition-group
          name="fadeIn"
          mode="out-in"
        >
          <div
            v-if="isLoading"
            key="loading"
            class="loading-block"
          >
            <ObLoader :size="35" />
          </div>
          <div
            v-if="!isLoading && !localItems.length"
            key="no-data"
            class="no-data-block"
          >
            Нет данных
          </div>
        </transition-group>
      </div>
    </select-dropdown>
  </div>
</template>

<script>
import Vue from 'vue'
import vueDebounce from 'vue-debounce'
import ClickOutside from 'vue-click-outside'
import SelectDropdown from '../obSelect/select-dropdown'
import ObLoader from '../obLoader'

Vue.use(vueDebounce)

export default {
  name: 'ObAutocomplete',

  components: {
    SelectDropdown,
    ObLoader
  },
  directives: {
    ClickOutside,
    scroll: {
      inserted: function (el, binding) {
        let f = function (evt) {
          if (binding.value(evt, el)) {
            el.removeEventListener('scroll', f)
          }
        }
        el.addEventListener('scroll', f)
      }
    }
  },
  props: {
    value: {
      type: Object,
      default: null
    },
    label: {
      type: String
    },
    placeholder: {
      type: String,
      default: 'Поиск'
    },
    actionIcon: {
      type: [ String, Boolean ],
      default: false
    },
    items: {
      type: Array,
      default: null
    },
    handAction: {
      type: Boolean,
      default: false
    },
    valueExp: {
      type: String,
      default: 'title'
    },
    showClear: {
      type: Boolean,
      default: true
    },
    isDisabled: {
      type: Boolean,
      default: false
    },
    isAlwaysAction: {
      type: Boolean,
      default: false
    },
    theme: {
      type: String,
      default: 'default'
    },
    popperClass: {
      type: String,
      default: null
    },
    remoteOpt: {
      type: [Function, Object],
      default: null
    },
    pageLimit: {
      type: Number,
      default: 20
    },
    isSelect: {
      type: Boolean,
      default: false
    },
    isInitListAfterSelect: {
      type: Boolean,
      default: false
    },
    dataQa: {
      type: String
    }
  },
  data () {
    return {
      localItems: [],
      searchQuery: '',
      showResults: false,
      selectedItem: null,
      focused: false,
      page: null,
      count: null,
      isLoading: false
    }
  },
  provide () {
    return {
      select: this
    }
  },
  computed: {
    isRemote () {
      return this.isRemoteFunction || this.isRemoteObject
    },
    isRemoteFunction () {
      return this.remoteOpt && typeof this.remoteOpt === 'function'
    },
    isRemoteObject () {
      return this.remoteOpt && typeof this.remoteOpt === 'object' && this.remoteOpt.method
    },
    isSelected () {
      return Boolean(this.selectedItem && this.selectedItem[this.valueExp])
    },
    isSelectedIcon () {
      return Boolean(this.selectedItem && this.selectedItem.icon)
    },
    wrapperClass () {
      return {
        '--focused': this.focused,
        '--disabled': this.isDisabled,
        [`--theme-${this.theme}`]: this.theme,
        '--is-select': this.isSelect
      }
    },
    displayValue () {
      return this.selectedItem ? this.selectedItem[this.valueExp] : ''
    },
    actionIconClass () {
      if (typeof this.actionIcon === 'boolean') {
        return 'modal-list'
      } else {
        return this.actionIcon
      }
    },
    localItemsFiltered () {
      if (this.isRemote) {
        return this.localItems
      } else {
        return this.localItems.filter((item) => {
          return item[this.valueExp].toString().toLowerCase().includes(this.searchQuery.toString().toLowerCase())
        })
      }
    }
  },
  watch: {
    value (val) {
      this.selectedItem = val
    },
    items (val) {
      this.localItems = val
    }
  },
  mounted () {
    this.selectedItem = this.value || null
    if (!this.isRemote) {
      this.localItems = this.items || []
    }
  },
  methods: {
    async loadData ({ concat = false, init = false, page, sort, search } = {}) {
      this.isLoading = true
      if (this.isRemote) {
        if (init) {
          this.page = 0
          this.count = 0
          if (this.$refs['list-container']) {
            this.$refs['list-container'].scrollTop = 0
          }
        }

        let promise = this.isRemoteFunction ? this.remoteOpt : this.remoteOpt.method
        let res = await promise(({ ...this.getRequestParams({ search, init, page, sort }) }))
        if (!res || res.error) {
          res = this.localItems
        }
        if (res && typeof res === 'object' && Object.keys(res).length === 1 && res.data) {
          res = res.data
        }

        let result = res
        let customKeyContent = this.isRemoteObject ? this.remoteOpt.contentKey : null
        if (result && !Array.isArray(result)) {
          result = (customKeyContent && result[customKeyContent]) || result.content || result.values || []
        } else if (!result) {
          result = []
        }

        this.count = res && (res.total_elements || res.totalElements || null)
        this.localItems = concat ? this.localItems.concat(result) : result
        this.prevTrigger = this.remoteTrigger
        this.firstLoad = false
        this.search = search !== undefined ? search : this.search
        this.$emit('on-load-list', this.localItems)
      } else {
        this.localItems = this.items || []
      }

      this.isLoading = false
    },
    getRequestParams ({ search, init, page, sort } = {}) {
      if (init) {
        page = 0
      } else {
        page = page !== undefined ? page : this.page
      }
      if (sort === undefined) {
        sort = this.sort
      }
      let params = {
        query: search !== undefined ? search : this.searchQuery,
        page: page,
        size: this.pageLimit,
        total: this.count
      }
      if (sort && sort.key) {
        params.sort = `${sort.key},${sort.direction ? 'desc' : 'asc'}`
      }
      let userArguments = {}

      if (this.isRemoteObject && this.remoteOpt.arguments) {
        userArguments = this.remoteOpt.arguments
      }
      return {
        ...params,
        ...userArguments
      }
    },
    handlerScroll (evt) {
      if (this.isLoading) {
        evt.preventDefault()
        evt.stopPropagation()
        return
      }
      if ((evt.target.scrollHeight - (evt.target.clientHeight + evt.target.scrollTop) < 72) && !this.isLoading && this.isRemote && (Math.floor(this.count / this.pageLimit) > this.page)) {
        this.isLoading = true
        this.page += 1

        this.loadData({ concat: true })
      }
    },
    onOutsideClick ($event) {
      let target = $event.target
      let popper = this.$refs.popper.$el
      if (target === popper || popper.contains(target)) {
        return false
      } else {
        this.showResults = false
        this.focused = false
      }
    },
    focusHandler (native = false) {
      if (!this.focused && !this.isSelected && !this.isDisabled) {
        this.focused = true
        this.$emit('focus')
        if (!native) {
          this.$refs.input && this.$refs.input.focus()
        }
        this.showResults = true
        if (!this.searchQuery && this.isRemote && !this.localItems.length) {
          this.loadData({ init: true })
        }
      }
    },
    blurHandler (e) {
      let isRelatedTarget = !e || (e && e.relatedTarget)
      if (this.focused && !this.$el.contains(document.activeElement) && isRelatedTarget) {
        this.$emit('blur')
        this.focused = false
      }
    },
    async onSearch () {
      this.$emit('search', this.searchQuery)
      if (this.isRemote) {
        await this.loadData({ init: true })
      }
      this.showResults = true
    },
    onClear () {
      this.searchQuery = ''
      this.selectedItem = null
      this.$emit('input', null)
    },
    onClickAction () {
      this.$emit('selectAction')
      this.showResults = false
      this.focused = false
    },
    onSelect (item) {
      if (item.isDisabled) return

      const search = this.searchQuery
      this.selectedItem = item
      this.searchQuery = ''
      this.showResults = false
      this.focused = false
      if (this.handAction) {
        this.$emit('handAction', item)
      }
      this.$emit('input', item)
      if (this.isInitListAfterSelect && Boolean(search)) {
        this.loadData({ init: true })
      }
    },
    highlight (text) {
      if (this.searchQuery === '' || !text) {
        return text
      }
      return text.replace(new RegExp(this.searchQuery, 'gi'), match => {
        return `<span style="color: #004BC8">${match}</span>`
      })
    },
    close () {
      this.showResults = false
    },
    show (event) {
      this.showResults = true
      if (event && !this.focused) {
        this.focusHandler(event)
      }
    },
    dropdownItemClass (item) {
      return {
        '--disabled': Boolean(item.isDisabled)
      }
    }
  }
}
</script>

<style lang="scss" scoped>
@import "../../static/css/variables";

.ob-autocomplete {
  position: relative;
  padding: 9px 12px;
  border-radius: 3px;
  background-color: white;
  transition: border-color 0.2s;
  &.--theme {
    &-blue {
      border: 1px solid $obAutocomplete-border_color_blue;
      &:hover {
        border-color: $cornflower-craiola;
      }
      &.--focused {
        border-color: $cobalt;
      }
    }
    &-default {
      border: 1px solid $color-grey-border;
      &:hover {
        border-color: $cornflower-craiola;
      }
      &.--focused {
        border-color: $cobalt;
      }
    }

    &-blue {
      &.--disabled {
        background-color: $lavender;
        border-color: $cornflower-craiola !important;
      }
    }
    &-default {
      &.--disabled {
        background-color: $color-white-lilac;
        border-color: $color-white-lilac !important;
      }
    }
  }

  &:hover,
  &.--focused,
  &.--is-select {
    .ob-autocomplete__action {
      opacity: 1;
    }
  }
  &.--is-select {
    .ob-autocomplete__action--out {
      order: -1;
    }
  }
  &.--disabled {
    cursor: not-allowed;

    .ob-autocomplete__input {
      cursor: inherit;
    }

    .ob-autocomplete__action:not(.ob-autocomplete__action--out) {
      display: none;
    }
  }

  &__input {
    width: 100%;
    background-color: transparent;
    font-size: 16px;
    line-height: 20px;
    letter-spacing: 0.2px;
    color: $color-text-base;
    outline: none;
    border: none;
  }

  &__main {
    display: flex;
    justify-content: space-between;
    align-items: center;

    .col-left {
      max-width: 100%;
      flex-grow: 2;
      min-width: 0;
      &__label {
        margin-bottom: 6px;
        font-size: 12px;
        line-height: 14px;
        letter-spacing: 0.4px;
        color: $gray-slate;
        white-space: nowrap;
        overflow: hidden;
        text-overflow: ellipsis;
      }

      &__value {
        position: relative;
        top: -1px;
        display: flex;
        justify-content: flex-start;
        align-items: center;
        height: 20px;
        font-size: 16px;
        line-height: 20px;
        &-text, & > div:not(.col-left__value-icon) {
          white-space: nowrap;
          overflow: hidden;
          text-overflow: ellipsis;
        }

        &-icon {
          margin-right: 5px;
          font-size: 24px;
        }
      }
    }
    .col-right {
      display: flex;
      justify-content: space-between;
      align-items: center;
      flex-shrink: 0;

      & > button,
      & > i {
        margin-left: 12px;

        &:first-child {
          margin-left: 8px;
        }
      }

      i {
        font-size: 24px;

        &.close {
          font-size: 14px;
        }
      }
    }
  }

  &__description {
    height: 38px;
    overflow: hidden;
    margin-top: 3px;
    font-size: 12px;
    line-height: 20px;
    letter-spacing: 0.2px;
    color: $color-grey-label;
  }

  &__action {
    display: flex;
    justify-content: center;
    align-items: center;
    width: 24px;
    height: 24px;
    opacity: 0;
    background-color: transparent;
    outline: none;
    border: none;
    appearance: none;
    transition: opacity 0.2s;
    cursor: pointer;

    &:hover {
      opacity: 0.8 !important;
    }

    .icon {
      color: $cobalt;

      &.close {
        color: $color-grey-span;
      }
    }
  }
  &__results {
    max-height: 300px;
    min-height: 56px;
    overflow: auto;
    padding: 10px 0;
    font-size: 16px;
    line-height: 22px;
    letter-spacing: 0.2px;
    color: $cobalt-black;
    background-color: white;
    box-shadow: 0 4px 8px rgba($color-blue-navy-blue, 0.25);
    border-radius: 3px;
    &-item {
      display: flex;
      align-items: center;
      padding: 7px 16px;

      &:hover {
        background-color: $light-lavender;
      }

      .icon {
        position: relative;
        margin-right: 10px;
        font-size: 22px;
      }

      &.--disabled {
        background-color: $gray-200;
        cursor: not-allowed;
        p {
          color: $gray-window;
        }
      }
    }

    .loading-block {
      position: absolute;
      top: 0;
      left: 0;
      width: 100%;
      height: 100%;
      display: flex;
      justify-content: center;
      align-items: center;
      background-color: $obAutocomplete-results_loading_block_background;
    }

    .no-data-block {
      width: 100%;
      height: 36px;
      display: flex;
      align-items: center;
      justify-content: center;
      text-align: center;
      font-size: 16px;
      color: $color-grey-span;
    }
  }

  .fadeIn-enter, .fadeIn-leave-to {
    opacity: 0;
  }
  .fadeIn-enter-active, .fadeIn-leave-active {
    transition: all .2s ease-in-out;
  }
}
</style>
